Home | History | Annotate | Download | only in move
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test14} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST14***************"
     29 tst_resm TINFO "move: uncloneable subtree to private parent."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of move/test14 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 	"${FS_BIND_ROOT}/bin/makedir" unclone dir
     44 	"${FS_BIND_ROOT}/bin/makedir" priv parent2
     45 	"${FS_BIND_ROOT}/bin/makedir" share share2
     46 
     47 	mkdir dir/grandchild
     48 	mkdir parent2/child2
     49 	mount --move dir parent2/child2
     50 
     51 	mount --bind parent2 share2
     52 	check  -n parent2/child2/ share2/child2/
     53 
     54 	break
     55 done
     56 trap 'ERR=$? ; tst_resm TWARN "move/test14: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     57 if [ -n "${ERR_MSG}" ]; then
     58 	tst_resm TWARN "move/test14: ${ERR_MSG}"
     59 	ERR_MSG=""
     60 	result=$ERR
     61 fi
     62 trap '' ERR
     63 {
     64 	umount share2
     65 	umount parent2/child2
     66 	umount dir # if the move fails
     67 	umount share2
     68 	umount parent2
     69 	umount dir
     70 
     71 	rm -rf dir parent* share*
     72 	cleanup
     73 } >& /dev/null
     74 if [ $result -ne 0 ]
     75 then
     76 	tst_resm TFAIL "move/test14: FAILED: move: uncloneable subtree to private parent."
     77 	exit 1
     78 else
     79 	tst_resm TPASS "move/test14: PASSED"
     80 	exit 0
     81 fi
     82 tst_exit
     83